routes/web.php
<?php

Route::get('/', function () {
    return view('auth.login');
});


// Route::get('even', function () {
// 	    event(new \App\Events\NuevaOrdenEvent('MOOOOOOOOOOOOOOOOOOOOOOOY'));
// 	    //return "Event has been sent!";
// 		//dd(event(new \App\Events\NuevaOrdenEvent('hello world')));
// 	});

Route::post('ocr', 'OcrController@readImage');

Route::get('ocr/test', 'OcrController@test');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

// Route::get('auth/{provider}', 'Auth\SocialAuthController@redirectToProvider')->name('social.auth');
// Route::get('auth/{provider}/callback', 'Auth\SocialAuthController@handleProviderCallback');

Route::get('auth/google', 'Auth\GoogleController@redirectToGoogle');
Route::get('auth/google/callback', 'Auth\GoogleController@handleGoogleCallback');

Route::get('auth/facebook', 'Auth\FacebookController@redirectToFacebook');
Route::get('auth/facebook/callback', 'Auth\FacebookController@handleFacebookCallback');

Route::group(['middleware' => 'auth'], function(){

	Route::resource('roles', 'RoleController');
	Route::resource('permissions', 'PermissionsController');
	
	Route::group(['middleware' => ['Administrador']], function () {
		Route::resource('users', 'UsersController');
	});

	Route::resource('passwords', 'ReiniciarPasswordController');
	Route::resource('persona', 'PersonaController');

	Route::resource('archivo','ControllerArchivo');
	Route::resource('repositorio','ControllerRepositorioArchivo');
	Route::resource('comparar','ArchivoCompararController');
	
	Route::resource('categoriaproyectos','CategoriaProyectoController');
	Route::resource('proyectos','ProyectoController');
	Route::resource('asignacion','AsignacionController');
	Route::resource('gestionversiones','GestionVersionController');
	Route::resource('archivoproyecto','GestorArchivoController');
	Route::resource('usuariobloqueado','UserBloqueadoController');
	Route::resource('ocr', 'OcrController');
	Route::resource('redaccion', 'RedaccionController');
	Route::resource('plagionline', 'GoogleSearchController');
	
	

	//Roles
	Route::get('list_roles', 'RoleController@list_roles');
	Route::PUT('actualizarRoles/{criterio}', 'RoleController@actualizarRoles');
 
	//Usuario
	Route::get('/list_user', 'UsersController@list_user');
	Route::get('/bajaUsuario', 'UsersController@bajaUsuario');
	Route::get('/activarUsuario', 'UsersController@activarUsuario');
	
	Route::get('profile', 'UsersController@profile');
	Route::put('actualizardatos/{criterio}', 'UsersController@actualizardatos');

	Route::post('storePersonalizar','UsersController@storePersonalizar')->name('personalizar.store');
	Route::get('getPersonalizar','UsersController@getPersonalizar')->name('personalizar.show');
	
	Route::PUT('addRole/{criterio}/{role}','UsersController@addRole');
	//usuario bloqueado
	Route::get('/list_userbloqueado', 'UserBloqueadoController@list_userbloqueado');
	Route::get('/activarUsuarioBloqueado', 'UserBloqueadoController@activarUsuarioBloqueado');
	
	//ip bloqueo
	Route::get('/list_ipbloqueado', 'UserBloqueadoController@list_ipbloqueado');
	Route::post('/storeIp', 'UserBloqueadoController@storeIp')->name('blockip.store');
	Route::get('/activarIpBloqueado', 'UserBloqueadoController@activarIpBloqueado');
	
	//Persona
	Route::get('/listar_personas', 'PersonaController@listar_personas');
	Route::get('/get_allciudades', 'PersonaController@get_allciudades');
	Route::get('/get_usuariosdisponibles', 'PersonaController@get_usuariosdisponibles');
	
	Route::get('/get_allUsuarios', 'PersonaController@get_allUsuarios');
	Route::post('/actualizarPersonal/{id}', 'PersonaController@actualizarPersonal');


	//tipoarchivo
	Route::get('listar_tparchivos','ControllerArchivo@listar_tparchivos');
	Route::get('listar_extension','ControllerArchivo@listar_extension');
	Route::get('editExtension/{criterio}','ControllerArchivo@editExtension');
	Route::post('storeExtension','ControllerArchivo@storeExtension')->name('extension.store');
	Route::put('updateExtension/{criterio}','ControllerArchivo@updateExtension')->name('extension.update');
	Route::get('bajaExtension','ControllerArchivo@bajaExtension');
	Route::get('activarExtension','ControllerArchivo@activarExtension');
	Route::get('getArchivo','ControllerArchivo@getArchivo');

	//Repositorio
	Route::get('getExtensiones','ControllerRepositorioArchivo@getExtensiones');
	Route::get('getArchivo/{criterio}','ControllerRepositorioArchivo@getArchivo');
	Route::get('listar_repositorio','ControllerRepositorioArchivo@listar_repositorio');
	Route::post('actualizarrepositorio','ControllerRepositorioArchivo@actualizarrepositorio');

	//ArchivoComparar

	Route::get('listar_comparar','ArchivoCompararController@listar_comparar');
	Route::get('leerDocumento','ArchivoCompararController@leerDocumento');
	Route::get('convertirPDF','ArchivoCompararController@convertirPDF');
	Route::get('getArchivo2/{criterio}','ArchivoCompararController@getArchivo2');
	Route::get('getComparacion/{fileres}/{file}','ArchivoCompararController@getComparacion');

	//resultado
	Route::get('listar_resultados','ArchivoCompararController@listar_resultados');
	Route::get('resultadoIndex','ArchivoCompararController@resultadoIndex')->name('resultado.index');
	Route::get('getResultados','ArchivoCompararController@getResultados');

	//proyectos
	Route::get('listar_proyectos','ProyectoController@listar_proyectos');

	Route::get('estadoProyecto','ProyectoController@estadoProyecto');
	Route::get('getArchivoProyecto/{criterio}','ProyectoController@getArchivoProyecto');

	//Asignacion usuario
	Route::get('actualizarAsignacion','AsignacionController@actualizarAsignacion');
	Route::get('listar_asignacion','AsignacionController@listar_asignacion');

	//Gestor Archivos
	Route::get('listar_archivosp/{criterio}','ProyectoController@listar_archivosp');
	Route::get('getDocumento/{criterio}/{name}','GestorArchivoController@getDocumento');
	Route::get('listadoDirectorio/{id}/{criterio}/{ini}/{original}','GestorArchivoController@listadoDirectorio');
	
	Route::get('eliminarArchivo/{dir}/{dirhere}/','GestorArchivoController@eliminarArchivo');
	Route::get('leerDocumento2','GestorArchivoController@leerDocumento2');
	Route::get('listar_resultados2','GestorArchivoController@listar_resultados2');
	Route::get('resultadoproyecto','GestorArchivoController@resultadoproyecto')->name('resultadoproyecto.index');
	Route::get('getResultados2','GestorArchivoController@getResultados2');
	//categoria proyecto
	Route::get('listar_Categorias','CategoriaProyectoController@listar_Categorias');

	//gestionversiones
	Route::get('listar_Versiones/{criterio}','GestionVersionController@listar_Versiones');
	Route::get('getVersion/{criterio}','GestionVersionController@getVersion');
	Route::get('getCambios/{criterio}','GestionVersionController@getCambios');
	Route::delete('eliminarVersion','GestionVersionController@eliminarVersion');
	Route::get('getVersion2/{criterio}','GestionVersionController@getVersion2');


	//OCR
	Route::get('listar_ocr','OcrController@listar_ocr');
	Route::get('leerDocumentoOCR','OcrController@leerDocumentoOCR');
	Route::get('getArchivoOcr/{criterio}','OcrController@getArchivoOcr');
	Route::delete('eliminarArchivoOcr/{criterio}','OcrController@eliminarArchivoOcr');
	
	Route::get('recortarImagen','OcrController@recortarImagen');

	//Redaccion
	Route::get('listar_redacciones','RedaccionController@listar_redacciones');
	Route::get('veredaccion/{criterio}','RedaccionController@indexEditor');
	Route::get('getRedaccion/{criterio}','RedaccionController@getRedaccion');
	Route::post('guardarTexto','RedaccionController@guardarTexto');
	Route::delete('eliminarRedaccion/{criterio}','RedaccionController@eliminarRedaccion');
	Route::post('storeUsuario','RedaccionController@storeUsuario')->name('adduser.store');

	//api google
	Route::get('gerResultados/{contenido}', 'GoogleSearchController@gerResultados');
	Route::get('indexGoogleSearch/{contenido}', 'GoogleSearchController@indexGoogleSearch');
});

Route::get('clear-cache', function() {
    $exitCode = Artisan::call('config:clear');
    $exitCode = Artisan::call('cache:clear');
    $exitCode = Artisan::call('config:cache');
    
    return 'DONE';
}); ;
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

resources/views/admin/asignaciones/index.blade.php
        @extends('template.app')

@section('title','Lista Asignar Usuarios')
@section('main-content')
<link rel="stylesheet" href="{{asset('plugins/flatpickr/css/flatpickr.min.css')}}">
<link href="{{ asset('plugins/select2/select2.min.css')}}" rel="stylesheet" />
<link href="{{ asset('plugins/select2/select2-bootstrap4.min.css')}}" rel="stylesheet" />

<div class="row"> 
	<div class="col-md-12">
        <!-- if(Auth::user()->role->permission->add == 1) -->
		<div align="left" style="border:auto;">
		    <button type="button" class="btn btn-info"  data-toggle="modal" data-target="#modal-Rasignacion">
		        Nueva Asignacion
		    </button>
		</div>
        <!-- endif -->
		<hr>
		<div class="table-responsive">
		    <table id="Tabla-Asignacion" class="table table-bordered table-striped" width="100%">
		        <thead> 
		            <tr>
		                <th>#</th>
		                <th>NOMBRE DEL PROYECTO</th>
		                <th>USUARIO ASIGNADO</th>
                        <th>ASIGNADO POR</th>
                        <th>FECHA CREADO</th>
                        <th>FECHA EXPIRACION</th>
                        <th>ESTADO</th>
		                <th>ACCION</th>
		            </tr>
		        </thead>
		        <tbody style="text-align: center;">
 
		        </tbody>
		    </table>
		</div>
	</div> 
</div>


@include('admin.asignaciones.modal-crear')
@include('admin.asignaciones.modal-editar')
 
@endsection

@section('js')
<script src="{{asset('plugins/flatpickr/js/flatpickr.js')}}"></script>
<script src="{{asset('plugins/select2/select2.min.js')}}"></script> 
<script src="{{asset('plugins/select2/maximize-select2-height.js')}}"></script> 
<script type="text/javascript">
        // $( document ).ajaxStart(function() {
        // $('.theme-loader').css('opacity','none');
        // $('.theme-loader').show();
        // }); 

        // $( document ).ajaxStop(function() {
        // $('.theme-loader').hide();
        // });

    jQuery(document).ready(function($) {
        cambio();    
    });

	function activar_tabla_asignacion() {
    	var t = $('#Tabla-Asignacion').DataTable({
        "processing"  : true,
        "serverSide"  : true,
        "searchDelay" : 500 ,
        "lengthMenu": [5,10, 25, 50, 75 ],
        "responsive": true,
        "language": {
        "url": '{!! asset('/plugins/datatables.net/latino.json') !!}',
        },
        "ajax":'{!! url('listar_asignacion') !!}',
        columns: [
            {data: 'id' },
            {data: 'nombre' },
            {data: 'username' },
            {data: 'creadopor'},
            {data: 'created_at' },
            {data: 'tiempo' },
            {data: 'estado',
                render: function(data, type, row, meta) {
                    var html = ''
                    if ( row.estado == 'activo' )
                    {
                        html = '<span class="badge badge-success" style="width:80px;"> Activo </span>';
                                
                    }else {
                        html = '<span class="badge badge-danger" style="width:80px;"> Inactivo </span>';
                    }
                    return html;
                }
            },
            {
            "defaultContent" : " ",
            "searchable" : false,
            "orderable" : false,
            "render" : function(data, type, row, meta) {
                var html='<div class="form-group" >';

                    html+='<a style="width:100px; margin:5px;" data-toggle="modal" data-target="#modal-Easignacion" class="btn btn-warning btn-xs text-white" onclick="llenarDatosEdit('+row.id+');"><i class="fas fa-wrench"></i> Editar </a> </br>';

                html +="</div>";
                return html;
            },
        }]
    });
	t.on( 'draw.dt', function () {
        var PageInfo = $('#Tabla-Asignacion').DataTable().page.info();
             t.column(0, { page: 'current' }).nodes().each( function (cell, i) {
                cell.innerHTML = i + 1 + PageInfo.start;
            } );
        } );
    } 
    activar_tabla_asignacion();

    $("#btnRasignacion").click(function(){
        var proyecto_id = $("#Rproyecto").val();
        var user_id = $("#Ruser").val();
        var tiempo = $("#fecha").val();
        var roles = $("#Rrole").val();
        var route = "{{route('asignacion.store')}}";
        var token = $("input[name=_token]").val();
        $.ajax({ 
            url:route,
            method:'POST',
            headers : {'X-CSRF-TOKEN':token},
            dataType:'json',
            data: {proyecto_id,user_id,tiempo,roles},
            success : function(data){
                if(data.mensaje == '')
                {   
                    $("#modal-Rasignacion").modal('toggle');
                    toastr.success('Asignacion Registrado');
                    $("#Tabla-Asignacion").DataTable().ajax.reload();
                }else 
                {
                    toastr.error(data.mensaje);
                }
                
            },
            error : function(data){
                toastr.error('ERROR');
            }
        });
    });

    $("#btnEasignacion").click(function(event) {
        var criterio = $("#criterioAsignacion").val()
        var proyecto_id = $("#Eproyecto").val(); 
        var user_id = $("#Euser").val();
        var tiempo = $("#Efecha").val();
        var roleproyecto_id = $("#Erole").val();
        var route = "{{url('updateAsignacion')}}/"+criterio;
        var token = $("input[name=_token]").val();
        $.ajax({ 
            url:route,
            method:'PUT',
            headers : {'X-CSRF-TOKEN':token},
            dataType:'json',
            data: {proyecto_id,user_id,tiempo,roleproyecto_id},
            success : function(data){
                    $("#modal-Easignacion").modal('toggle');
                    toastr.success('Asignacion Actualizada');
                    $("#Tabla-Asignacion").DataTable().ajax.reload();               
            },
            error : function(data){
                toastr.error('ERROR');
            }
        });
    });

	function cargarextension()
	{	
		var route = "{{url('getExtensiones')}}";
		$.ajax({
			url:route,
			method : 'get',
			success: function(data){
				var extension = [];
				for(var i=0; i<data.length; i++)
				{
					extension.push(data[i].extension.toLowerCase());
				}
				$('#RFarchivo').fileinput('destroy').fileinput(
                {
                	language: 'es',
			        dropZoneEnabled: false,
			        showUpload : false,
			        allowedFileExtensions: extension
               	});

               	$('#EFarchivo').fileinput('destroy').fileinput(
                {
                	language: 'es',
			        dropZoneEnabled: false,
			        showUpload : false,
			        allowedFileExtensions: extension
               	});
			}
		})
	}

    function llenarDatosEdit(criterio)
    {
        var route = "{{url('asignacion')}}/"+criterio+"/edit";
        $.get(route, function(data){
            console.log(data);
            if(data.asignacion.user_id == data.asignacion.creadopor)
            {
                console.log('ok');
                $('#criterioAsignacion').val(data.asignacion.id);
                //time.setDate(data.tiempo,true);
                $("#Eproyecto").val(data.asignacion.proyecto_id);
                $("#Efecha").prop( "disabled", true );
                $("#Euser").val(data.asignacion.user_id).prop( "disabled", true );
                $("#Erole").val('JefeProyecto').prop( "disabled", true );
            }else{
                $('#criterioAsignacion').val(data.asignacion.id);
                $("#Eproyecto").val(data.asignacion.proyecto_id);
                $("#Efecha").prop( "disabled", false );
                time.setDate(data.tiempo,true);
                $("#Euser").val(data.asignacion.user_id).prop( "disabled", false );
                for(var i=0; i<data.usuario.roles.length; i++)
                {
                    $("#Erole").val(data.usuario.roles[i].name).prop( "disabled", false );
                }
            }
        });
    }

    $("#fecha").flatpickr({
        minDate: new Date(),
        //defaultDate: new Date(),
        dateFormat: "Y-m-d ",
        disableMobile: "true"
    });
//flatpickr.setDate(new Date('2017/12/04'))
    var time = $("#Efecha").flatpickr({
        minDate: new Date(),
        //defaultDate: new Date(),
        dateFormat: "Y-m-d ",
        disableMobile: "true"
    });
	//cargarextension();

    function cambio (){
        var route = "{{url('getPersonalizar')}}"
        var token = $("input[name=_token]").val();
        $.ajax({
            url : route,
            headers : {'X-CSRF-TOKEN':token},
            method : 'get',
            //dataType : 'json',
            //data : estiloGlobal,
            success : function (data)
            {
                for (var i = 0; i < data.length; i++) {
                if(data[i].nav_type != null)
                    $(".pcoded").attr("nav-type", data[i].nav_type);
                if(data[i].navbar_logo != null) 
                    $(".navbar-logo").attr("logo-theme", data[i].navbar_logo)
                if(data[i].pcoded_navigatio_lavel != null)
                    $(".pcoded-navigatio-lavel").attr("menu-title-theme", data[i].pcoded_navigatio_lavel)
                if(data[i].pcoded_header != null)
                    $(".pcoded-header").attr("header-theme", data[i].pcoded_header)
                if(data[i].pcoded_navbar != null)                        
                    $(".pcoded-navbar").attr("navbar-theme", data[i].pcoded_navbar)
                if(data[i].active_item_them != null)
                    $(".pcoded-navbar").attr("active-item-theme", data[i].active_item_them)
                if(data[i].sub_item_theme != null)
                    $(".pcoded-navbar").attr("sub-item-theme", data[i].sub_item_theme)
                if(data[i].themebg_pattern != null)
                    $("body").attr("themebg-pattern", data[i].themebg_pattern)
                if(data[i].vertical_effect != null)
                    $(".pcoded").attr("vertical-effect", data[i].vertical_effect)
                if(data[i].item_border_style != null)
                    $(".pcoded-navbar .pcoded-item").attr("item-border-style", data[i].item_border_style)
                if(data[i].dropdown_icon != null)
                    $(".pcoded-navbar .pcoded-hasmenu").attr("dropdown-icon", data[i].dropdown_icon)
                if(data[i].subitem_icon != null)
                    $(".pcoded-navbar .pcoded-hasmenu").attr("subitem-icon", data[i].subitem_icon)
                var usuario = '{{Auth::user()->id}}';
                if(data[i].imagen != null)
                {
                    var url = 'personalizado/user/'+usuario+'/'+data[i].imagen;
                    $('head').append('<style>.main-menu:before{content: ""; background-image: url('+url+'); background-size: cover; position: absolute; top: 0px; right: 0px; bottom: 0px; left: 0px; opacity: 0.2;}</style>');
                    
                }
                }
                
            },
            error : function (data){
                toastr.error("ERROR");
            }
        })
    };

    $('#Ruser').select2({
        placeholder: "Seleccione un Usuario",
        maximumSelectionSize: 1,
        allowClear: true,
        width: '100%',
        theme: "bootstrap4",
        dropdownParent: $('#modal-Rasignacion'),
        minimumInputLength : 1
    });  
</script>
<style type="text/css">
.flatpickr-calendar.open {
z-index: 99999999999 !important;
}
.flatpickr-calendar.static {
top: -300px;
}
</style>
@endsection

resources/views/admin/asignaciones/modal-crear.blade.php
<div class="modal fade" id="modal-Rasignacion" data-backdrop="static" data-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
	<div class="modal-dialog">
		{!! Form::open(['id'=> 'FRNasignacion','autocomplete' => 'off']) !!}
		<div class="modal-content">
		  	<div class="modal-header bg-primary">
		    	<h5 class="modal-title" >Formulario Nueva Asignacion</h5>
			    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
			      	<span aria-hidden="true">&times;</span>
			    </button>
		  	</div>
		  	<div class="modal-body">
				<div class="form-group">
					<div class="row">
						<div class="col-md-12">
							{!! Form::label('type','Proyectos') !!}
							{!! Form::select(
								'proyecto_id',$proyectos,
								null,
								['class'=>'form-control',
								'placeholder'=>'Seleccione una Opcion...',
								'id'=>'Rproyecto']) !!} 
						</div>
					</div>
				</div>
				<div class="form-group">
					<div class="row">
						<div class="col-md-12">
							{!! Form::label('fecha','Fecha de expiración') !!}
						  	{!! Form::text('tiempo',null, 
						  		['class'=>'form-control' ,'id'=>'fecha']) !!}
							
						</div>
					</div>
				</div>
				<div class="form-group">
					<div class="row">
						<div class="col-md-12">
							{!! Form::label('type','Usuarios') !!}
							{!! Form::select(
								'user_id',$users,
								null,
								['class'=>'form-control',
								'placeholder'=>'Seleccione una Opcion...',
								'id'=>'Ruser']) !!} 
						</div>
					</div>
				</div>
				<div class="form-group">
					<div class="row">
						<div class="col-md-12">
							{!! Form::label('type','Roles') !!}
							{!! Form::select(
								'roles',$Roles,
								null,
								['class'=>'form-control',
								'placeholder'=>'Seleccione una Opcion...',
								'id'=>'Rrole']) !!} 
						</div>
					</div>
				</div>
		  	</div>
		  	<div class="modal-footer">
			    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
			    {!!link_to('#', $title='Registrar Asignacion', 
				$attributes = ['id'=>'btnRasignacion', 'class'=>'btn btn-primary'])!!}
		  	</div>
		</div>
		{!! Form::close() !!}
	</div>
</div>

resources/views/admin/asignaciones/modal-editar.blade.php
<div class="modal fade" id="modal-Easignacion" data-backdrop="static" data-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
	<div class="modal-dialog">
		{!! Form::open(['id'=> 'FRNEasignacion','autocomplete' => 'off']) !!}
		<div class="modal-content">
		  	<div class="modal-header bg-primary">
		    	<h5 class="modal-title" >Editar Asignacion</h5>
			    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
			      	<span aria-hidden="true">&times;</span>
			    </button>
		  	</div>
		  	<div class="modal-body">
		  		<input type="hidden" id="criterioAsignacion" value="">
				<div class="form-group">
					<div class="row">
						<div class="col-md-12">
							{!! Form::label('type','Proyectos') !!}
							{!! Form::select(
								'proyecto_id',$proyectos,
								null,
								['class'=>'form-control',
								'placeholder'=>'Seleccione una Opcion...',
								'id'=>'Eproyecto']) !!} 
						</div>
					</div>
				</div>
				<div class="form-group">
					<div class="row">
						<div class="col-md-12">
							{!! Form::label('fecha','Fecha de expiración') !!}
						  	{!! Form::text('tiempo',null, 
						  		['class'=>'form-control' ,'id'=>'Efecha']) !!}
							
						</div>
					</div>
				</div>
				<div class="form-group">
					<div class="row">
						<div class="col-md-12">
							{!! Form::label('type','Usuarios') !!}
							{!! Form::select(
								'user_id',$users,
								null,
								['class'=>'form-control',
								'placeholder'=>'Seleccione una Opcion...',
								'id'=>'Euser']) !!} 
						</div>
					</div>
				</div>
				<div class="form-group">
					<div class="row">
						<div class="col-md-12">
							{!! Form::label('type','Roles') !!}
							{!! Form::select(
								'roleproyecto_id',$Roles,
								null,
								['class'=>'form-control',
								'placeholder'=>'Seleccione una Opcion...',
								'id'=>'Erole']) !!} 
						</div>
					</div>
				</div>
		  	</div>
		  	<div class="modal-footer">
			    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
			    {!!link_to('#', $title='Actualizar Asignacion', 
				$attributes = ['id'=>'btnEasignacion', 'class'=>'btn btn-primary'])!!}
		  	</div>
		</div>
		{!! Form::close() !!}
	</div>
</div>